MODULE DISPL_CALC
 
  IMPLICIT NONE

CONTAINS

   SUBROUTINE DSPLISO(EESUM,EEDIF,UUZZ,CHI)
        Use Input_Data
     IMPLICIT NONE
     REAL, INTENT(IN   ) :: CHI
     REAL, INTENT(  OUT) :: EESUM,EEDIF,UUZZ

     DOUBLE PRECISION :: AASUM,AADIF,AAZZ

     !!! COMMON
     REAL :: RHO,ZETA,ETA
     COMMON /QAGON/RHO,ZETA,ETA

     ETA=1.E0
     CALL DPREST(AASUM,AADIF,AAZZ)

     EESUM = - BIAUX*(AASUM+CHI)
     EEDIF = BIAUX*(AADIF-CHI)
     UUZZ  = -BIAUX*AAZZ

   END SUBROUTINE DSPLISO

   SUBROUTINE DSPLANISO(EESUM,EEDIF,UUZ,CHI)
        Use Input_Data
     IMPLICIT NONE
     REAL, INTENT(IN   ) :: CHI
     REAL, INTENT(  OUT) :: EESUM,EEDIF,UUZ

     DOUBLE PRECISION :: AASUM1,AADIF1,AAZ1,&
                         AASUM2,AADIF2,AAZ2

     !!! COMMON
     REAL :: RHO,ZETA,ETA
     COMMON /QAGON/RHO,ZETA,ETA

     ETA=ETA1
     CALL DPREST(AASUM1,AADIF1,AAZ1)
     ETA=ETA2
     CALL DPREST(AASUM2,AADIF2,AAZ2)

     EESUM =  CN1_2G*CHI + & !(2.E0*EPSA + CN1_2G)*CHI + &
             (CN02_1*AASUM2 - CN02_2*AASUM1)/ETA_DIF
     EEDIF = +CN1_2G*CHI - &
             (CN02_1*AADIF2 - CN02_2*AADIF1)/ETA_DIF
     UUZ  =  & !(EPSC*CHI)*ZETA + &
             (U1*AAZ2 - U2*AAZ1)/ETA_DIF

!    WRITE(12,'(10(E15.8,1X))')ZETA,RHO,AASUM1,AASUM2,AADIF1,AADIF2

     RETURN
     
   END SUBROUTINE DSPLANISO

   SUBROUTINE DPREST(AASUM,AADIF,AAZ)

      Use Input_Data, ONLY: RD,RC,ZC
   
   IMPLICIT NONE

!! 'dummy' and local variables !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

   DOUBLE PRECISION AASUM,AADIF,AAZ,RO,ZE

!! GAG Variables  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

   INTEGER, PARAMETER :: LIMITE=100
   DOUBLE PRECISION AL,AU,ABSERR,EPSABS,EPSREL,WORK(4*LIMITE)
   INTEGER IER,IWORK(LIMITE),KEY,LAST,LENW,LIMIT,NEVAL

   DOUBLE PRECISION, EXTERNAL :: I_FA00,I_FA20,I_FI00

   !!! COMMON
   REAL :: RHO,ZETA,ETA
   COMMON /QAGON/RHO,ZETA,ETA

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   
    RO=RHO
    ZE=ZETA
    AL=0.D0
    AU=DBLE(RD)

    EPSABS=0.D0
    EPSREL=1.D-4
    KEY=6
    LIMIT=LIMITE
    LENW=LIMIT*4
    
    CALL DQAG(I_FA00,AL,AU,EPSABS,EPSREL,KEY,AASUM,ABSERR,NEVAL, &
             IER,LIMIT,LENW,LAST,IWORK,WORK)

    IF (IER.NE.0) &
       CALL DQAG_CHECK("FA00","AASUM",AASUM,ABSERR,RO*RC,ZE*ZC,NEVAL,IER,LAST)

       CALL DQAG(I_FA20,AL,AU,EPSABS,EPSREL,KEY,AADIF,ABSERR,NEVAL, &
             IER,LIMIT,LENW,LAST,IWORK,WORK)

    IF (IER.NE.0) &
       CALL DQAG_CHECK("FA20","AADIF",AADIF,ABSERR,RO*RC,ZE*ZC,NEVAL,IER,LAST)

       CALL DQAG(I_FI00,AL,AU,EPSABS,EPSREL,KEY,AAZ,ABSERR,NEVAL, &
                IER,LIMIT,LENW,LAST,IWORK,WORK)
    IF (IER.NE.0) &
       CALL DQAG_CHECK("FI00","UUZ",AAZ,ABSERR,RO*RC,ZE*ZC,NEVAL,IER,LAST)

   RETURN
   END SUBROUTINE DPREST

   SUBROUTINE DQAG_CHECK(FUNC,RESNAME,RES,ABSERR,RO,ZE,NEVAL,IER,LAST)
   IMPLICIT NONE
   CHARACTER(LEN=*)    :: FUNC,RESNAME
   DOUBLE PRECISION    :: RES,ABSERR,RO,ZE
   INTEGER             :: NEVAL,IER,LAST
     WRITE(6,*)"ERROR AT: RHO: ",RO," ZETA: ",ZE
     WRITE(6,*)"QAG ",TRIM(FUNC)," ",TRIM(RESNAME)," RESULT=",RES
     WRITE(6,*)"QAG ABSERR=",ABSERR
     WRITE(6,*)"QAG NEVAL=",NEVAL
     WRITE(6,*)"QAG IER=",IER
     WRITE(6,*)"QAG LAST=",LAST

     RETURN
   END SUBROUTINE DQAG_CHECK

END MODULE DISPL_CALC
